public class Problema3 {

	static int[] a = { 23, 45, -34, 12, 0, 98, -99, 4, 189, -1, 4 };
	static int n = a.length;
	static int minimo = Integer.MAX_VALUE;
	static boolean[] solucion = new boolean[n];
	static boolean[] seleccionados = new boolean[n];

	public static void main(String[] args) {
		solve(a, 0);
		print(a, true);
		print(a, false);
	}

	// En cada paso, agregue o remueva el elemento actual del arreglo.
	// Verifique si se han seleccionado la cantidad necesaria de elementos y si es asi, actualice la solucion.
	// Verifique si ha alcanzado el fin del arreglo y si es asi, retorne.
	protected static void solve(int [] a, int actual) {

		// obtener el tamano de los elementos seleccionados
		int cantidadSeleccionados = 0;
		for (int i = 0; i < n; i++)
			if (seleccionados[i])
				cantidadSeleccionados++;

		if (cantidadSeleccionados == n / 2) {
			// Verificar si diferencia < minimo. Si es asi, actualizar arreglo de 'soluciones'
			int diferencia = obtenerDiferencia();
			if (diferencia < minimo) {
				minimo = diferencia;
				actualizarSolucion();
			}
		}

		// si se ha llegado al final, retornar
		if (actual >= n)
			return;

		// agregar el actual al arreglo de seleccionados y resolver
		seleccionados[actual] = true;
		solve(a, actual + 1);

		// remover el actual del arreglo de seleccionados y resolver
		seleccionados[actual] = false;
		solve(a, actual + 1);
	}

	protected static void actualizarSolucion() {
		for (int i = 0; i < n; i++) {
			solucion[i] = seleccionados[i];
		}
	}

	public static void print(int [] arreglo, boolean seleccionado) {
		System.out.print("[");
		for (int i = 0; i < arreglo.length; i++) {
			if (solucion[i] == seleccionado) {
				if (i < arreglo.length - 1) {
					System.out.print(arreglo[i] + " ");
				}
				else {
					System.out.print(arreglo[i]);
				}
			}
		}
		System.out.println("]");
		System.out.println(printSuma(seleccionado));
	}
	
	public static int printSuma(boolean seleccionado) {
		int suma = 0;
		for (int i = 0; i < n; i++) {
			if (solucion[i] == seleccionado) {
				suma += a[i];
			}
		}
		return suma;
	}

	public static int obtenerDiferencia() {
		int sumaT = 0;
		int sumaF = 0;

		for (int i = 0; i < n; i++) {
			if (seleccionados[i])
				sumaT += a[i];
			else
				sumaF += a[i];
		}
		return Math.abs(sumaF - sumaT);
	}
}