public class Problema4 {

	public static void main(String[] args) {
		int entrada [] = {10,9,8,7,6,5,4,3,2,1};
		int salida [] = new int[0];
		sortBacktracking(entrada, salida, 0);
	}
	
	public static int recursion = 0;
	
	public static boolean sortBacktracking(int [] entrada, int [] salida, int nivel) {		
		// Mostrar en pantalla la progresion
		recursion++;
		System.out.println(recursion + "# Nivel " + nivel + ": " + print(entrada) + " "+ print(salida));
		
		// Rechaza. No hay solucion.
		if (salida.length > 1 && (salida[salida.length - 2] > salida[salida.length - 1])){
			return false;
		}

		// Acepta
		if (entrada.length == 0) {
			System.out.print("Solucion: " + print(salida));
			return true;
		}
		
		// Iteramos por todas las posibilidades de la entrada
		for (int i = 0; i < entrada.length; i++) {
			int [] entradaNueva = remove(entrada, i);
			int [] salidaNueva = add(salida, entrada[i]);
			boolean ordenado = sortBacktracking(entradaNueva, salidaNueva, nivel++);
			if (ordenado){
				return ordenado;
			}
		}
		// No se encontro solucion
		return false;
	}

	/*
	 * params
	 * arreglo: el arreglo para hacer la operacion
	 * include: el elemento a agregar al final del arreglo
	 */
	private static int[] add(int[] arreglo, int include) {
		int [] ret = new int[arreglo.length + 1];
		int i = 0;
		while (i < arreglo.length) {
			ret[i] = arreglo[i];
			i++;
		}
		ret[i] = include;
		return ret;
	}

	/*
	 * params
	 * arreglo: el arreglo para hacer la operacion
	 * except: indice del elemento a dejar fuera
	 */
	private static int[] remove(int[] arreglo, int except) {
		int [] ret = new int[arreglo.length - 1];
		int i = 0;
		int j = 0;
		while(i < arreglo.length){
			if (i != except) {
				ret[j] = arreglo[i];
				j++;
			}
			i++;
		}
		return ret;
	}
	
	public static String print(int [] arreglo) {
		String ret = "";
		ret += "[";
		for (int i = 0; i < arreglo.length; i++) {
			if (i < arreglo.length - 1) {
				ret += arreglo[i] + " ";
			}
			else {
				ret += arreglo[i];
			}
		}
		ret += "]";
		return ret;
	}

	public static boolean sorted(int [] arreglo) {
		boolean ret = true;
		for (int i = 0; i < arreglo.length - 1; i++) {
			if(arreglo[i] > arreglo[i+1]) {
				ret = false;
				break;
			}
		}
		return ret;
	}
}